/* acconfig.h
   This file is in the public domain.

   Descriptive text for the C preprocessor macros that
   the distributed Autoconf macros can define.
   No software package will use all of them; autoheader copies the ones
   your configure.in uses into your configuration header file templates.

   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  Although this order
   can split up related entries, it makes it easier to check whether
   a given entry is in the file.

   Leave the following blank line there!!  Autoheader needs it.  */


// vi:ts=4:sw=4:

/* Define this to the OS type. "Unix" if not found or uname -s failed */
#undef EXPLORER_MACHNAME

#undef HAVE_SYS_UCRED_H

#undef HAVE_SYS_MOUNT_H

#undef HAVE_SYS_PARAM_H

#undef HAVE_GETMNTINFO

#undef HAVE_UNMOUNT

#undef HAVE_UMOUNT

#undef HAVE_STRERROR

#undef HAVE_MNTENT_H

/* Some badly installed g++ distribs don't include new.h */
#undef HAVE_NEW_H

/* use the windows 95 interface look */
#undef EXPLORER_WIN95_INTERFACE

/* Place to store our default data */
#undef EXPLORER_DATADIR

/* shared object, SunOS4 style */
#undef HAVE_DLFCN_H

/* Non ELF systems still have a leading underscore as a prefix for their variabeles */
#undef HAVE_DLSYM_UNDERSCORE

/* FreeBSD doesn't define this *sigh* */
#undef HAVE_RTLD_LAZY_DEFINE

/* shared objects, HP-UX style */
#undef HAVE_DL_H

