/*
 * vi:ts=4:sw=4:
 *
 * Project : "Linux Explorer"
 * Copyright 1996. All Rights Reserved.
 * 
 * $RCSfile: config_expl.h,v $
 *
 * $Revision: 1.3 $
 * 
 * $Author: ruben $ 
 * 
 * $Locker:  $
 * 
 * $State: Exp $
 * 
 * 
 * COPYRIGHT
 * =========
 * 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 * 
 * $Log: config_expl.h,v $
 * Revision 1.3  1997/06/09 12:59:23  ruben
 * switched rcs commands again I think...
 * compiled with -Wall -Werror, fixed bugs and potential bugs
 * fixed Mister Data bugs
 *
 * Revision 1.2  1997/05/27  09:02:10  ruben
 * reworked include strategy for developers ease
 *
 * Revision 1.2  1997/05/27  09:02:10  ruben
 * reworked include strategy for developers ease
 *
 * Revision 1.1  1997/03/28 17:48:16  ruben
 * Initial revision
 *
 */
 
#ifndef __CONFIG_EXPL_H__
#define __CONFIG_EXPL_H__ 

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <dirent.h>
#include <fcntl.h>
#include <unistd.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <string.h>

#include <qmsgbox.h>
#include <qlist.h>

#include "data_win.h"
#include "file_tool.h"


// must be last
#include "vars.h"

class   TypeClass
{
	private:

	char   *extention;
	char   *program;
	char   *icon_name;
	char   *arguments;

	public:

	void    set_extention(char *);
	void    set_program(char *);
	void    set_icon_name(char *);
	void    set_arguments(char *);

	char   *get_extention(void);
	char   *get_program(void);
	char   *get_icon_name(void);
	char   *get_arguments(void);

	int     test_ext(char *);
	int     execute_command(char *);

	        TypeClass(void);
	       ~TypeClass();
};

extern TypeClass *types[];		// currently 256 types maximum

extern int nr_types;

int     read_types();
int     save_types();

class   ConfigClass
{
  public:

	ConfigClass(void)
	{

	}

	int  load_resources(void);
	void unload_resources(void);
};

#endif	 // __CONFIG_EXPL_H__
