#ifndef __DATA_WIN_H__
#define __DATA_WIN_H__

/*
 * vi:ts=4:sw=4:
 *
 * Project : "Linux Explorer"
 * Copyright 1996. All Rights Reserved.
 * 
 * $RCSfile: data_win.h,v $
 *
 * $Revision: 1.4 $
 * 
 * $Author: ruben $ 
 * 
 * $Locker:  $
 * 
 * $State: Exp $
 * 
 * 
 * COPYRIGHT
 * =========
 * 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 * 
 * $Log: data_win.h,v $
 * Revision 1.4  1997/06/09 12:59:23  ruben
 * switched rcs commands again I think...
 * compiled with -Wall -Werror, fixed bugs and potential bugs
 * fixed Mister Data bugs
 *
 * Revision 1.3  1997/05/27  09:02:10  ruben
 * reworked include strategy for developers ease
 * also some indent done
 *
 * Revision 1.3  1997/05/27  09:02:10  ruben
 * reworked include strategy for developers ease
 * also some indent done
 *
 * Revision 1.2  1997/04/06 21:34:09  ruben
 * reworde char* signals to const char* ones
 *
 * Revision 1.1  1997/03/28 17:48:16  ruben
 * Initial revision
 *
 */

#include <qbitmap.h>
#include <qpainter.h>
#include <qdrawutl.h>

#include "data_tree.h"
#include "file_tool.h"
#include "dialogs.h"

extern char tempo_stringo []; // string used by goto_dir ()
extern char mouse_locked;     // this will probably not work 
                              // under multi-thread

void draw_rect (QPainter *,int,int,int,int);

extern char multiple_select;

//>-------------------

class   UpDownScroll:public QScrollBar
{

	Q_OBJECT

	private:

	QWidget * move_widget;
	int    *val_to_change;

	private slots:

	void    scrollBarValueChanged(int);

	public:

	        UpDownScroll(QWidget *, int *);
	void    set_parent(QWidget *);

};

//>-------------------

class   LeftRightScroll:public QScrollBar
{

	Q_OBJECT

	private:

	QWidget * move_widget;
	int    *val_to_change;

	private slots:

	void    scrollBarValueChanged(int);

	public:

	        LeftRightScroll(QWidget *, int *);
	void    set_parent(QWidget *);

};


#endif	 // __DATAWIN_H__



